package com.dky.generate;


import cn.hutool.json.JSONObject;
import com.dky.calculate.*;
import com.dky.modelI.DntdModelI;
import com.dky.tool.ModelTool;
import com.dky.utils.entity.SysDeviceHeatScene;
import com.dky.utils.result.MatchedDevice;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicReference;

public class BuildHeatingSence implements DntdModelI {

    DecimalFormat decimalFormat = new DecimalFormat("#.00");

    @Override
    public JSONObject createReport(JSONObject jsonObject2) {
        List<SysDeviceHeatScene> list = ModelTool.specList;
        JSONObject distInfo = (JSONObject) jsonObject2.get("distInfo");
        JSONObject buildInfo = (JSONObject) jsonObject2.get("buildInfo");
        System.out.println("时间: " + Integer.parseInt(buildInfo.get("days").toString()));
        // 运行容量
        Double runCapacity = Double.parseDouble(distInfo.get("runCapacity").toString());
        // 上年最大需量
        Double lastYearNeed = Double.parseDouble(distInfo.get("lastYearNeed").toString());
        // 建筑面积
        Double heatingArea = Double.parseDouble(buildInfo.get("heatingArea").toString());
        // 年采暖时间(天)
        Integer days = Integer.parseInt(buildInfo.get("days").toString());
        // 上年运行费用（万元）
        Double lastYearFee = Double.parseDouble(buildInfo.get("lastYearFee").toString());

        Double A = runCapacity * 0.9 * 0.85;
        // 冗余容量
        Double B = A - lastYearNeed;
        AtomicReference<Double> C = new AtomicReference<>();
        AtomicReference<Double> C1 = new AtomicReference<>();
        List<Map<String, List<List<MatchedDevice>>>> calScheme = Scheme.calScheme(heatingArea, list);
        List<Map<String, Double>> mapsC = CalC.getC(calScheme);
        for (Map<String, Double> map : mapsC) {
            map.forEach((k, v) -> {
                if (k.contains("电锅炉")) {
                    C.set(v);
                    System.out.println("C" + C.get());
                } else {
                    C1.set(v);
                    System.out.println("C1" + C1.get());
                }
            });
        }


        Double D = lastYearNeed + C.get();
        Double D1 = lastYearNeed + C1.get();
        List<MatchedDevice> matchedDeviceList;
        Map<Double, List<MatchedDevice>> listMap;
        // 判断只能用热泵
        if (D1 < A && A < D) {
            List<SysDeviceHeatScene> deviceList = new ArrayList<>();
            list.parallelStream().forEach((sysDeviceHeatScene -> {
                if (!sysDeviceHeatScene.getDevTechType().contains("电锅炉")) {
                    deviceList.add(sysDeviceHeatScene);
                }
            }));
            listMap = SchemeRating.getOptimalList(Scheme.calScheme(heatingArea, deviceList));
            matchedDeviceList = SchemeRating.getOptimalScheme(listMap);
        } else {
            listMap = SchemeRating.getOptimalList(calScheme);
            matchedDeviceList = SchemeRating.getOptimalScheme(listMap);
        }

        List<Map<String, Object>> maps = new ArrayList<>();
        listMap.forEach((k,v)->{
            Map<String, Object> map = new HashMap<>();
            map.put("rating", decimalFormat.format(k));
            map.put("plan", v);
            map.put("planName", v.get(0).getDeviceHeatScene().getDevTechType());
            maps.add(map);
        });

        JSONObject jsonObject = new JSONObject();
        AtomicReference<String> planInfos = new AtomicReference<>();
        AtomicReference<String> devTechType = new AtomicReference<>();
        AtomicReference<String> devSubType = new AtomicReference<>();
        AtomicReference<String> devCount = new AtomicReference<>();
        AtomicReference<String> devPrice = new AtomicReference<>();
        AtomicReference<Double> startCost = new AtomicReference<>(0.0);
        AtomicReference<Double> runCost = new AtomicReference<>(0.0);
        AtomicReference<Double> allCost = new AtomicReference<>(0.0);
        AtomicReference<Double> calculateAnnualCarbon = new AtomicReference<>(0.0);
        AtomicReference<Double> electric = new AtomicReference<>(0.0);
        matchedDeviceList.parallelStream().forEach((matchedDevice -> {
            planInfos.set(planInfos.get() + "设备: " + matchedDevice.getDeviceHeatScene().getDevType() + "，技术: " + matchedDevice.getDeviceHeatScene().getDevTechType() + "，数量 = " + matchedDevice.getCount() + "。");
            devTechType.set(devTechType.get() + "设备: " + matchedDevice.getDeviceHeatScene().getDevType() + "，技术: " + matchedDevice.getDeviceHeatScene().getDevTechType() + "。");
            devSubType.set(devSubType.get() + "设备: " + matchedDevice.getDeviceHeatScene().getDevType() + "，设备细类: " + matchedDevice.getDeviceHeatScene().getDevSubType() + "。");
            devCount.set(devCount.get() + "设备: " + matchedDevice.getDeviceHeatScene().getDevType()  + "，数量 = " + matchedDevice.getCount() + "。");
            devPrice.set(devPrice.get() + "设备: " + matchedDevice.getDeviceHeatScene().getDevType()  + "，单价 = " + matchedDevice.getDeviceHeatScene().getDevPrice() + "。");
            startCost.set(startCost.get() + (matchedDevice.getCount() * matchedDevice.getDeviceHeatScene().getDevPrice()));
            runCost.set(runCost.get() + (BuildHeatingModel.getRunCost(matchedDevice.getCount(), matchedDevice.getDeviceHeatScene().getDevPower(), days, matchedDevice.getDeviceHeatScene().getDevSubstituteLaborCost())));
            allCost.set(allCost.get() + (BuildHeatingModel.getYearCost(matchedDevice.getCount(), matchedDevice.getDeviceHeatScene().getDevPrice(), matchedDevice.getDeviceHeatScene().getDevServiceLife(), matchedDevice.getDeviceHeatScene().getDevPower(), days, matchedDevice.getDeviceHeatScene().getDevSubstituteLaborCost())));
            calculateAnnualCarbon.set(calculateAnnualCarbon.get() + (BuildHeatingModel.calculateAnnualCarbonReduction(lastYearFee, matchedDevice.getDeviceHeatScene().getLaborCost(), matchedDevice.getCount(), matchedDevice.getDeviceHeatScene().getDevPower(), days)));
            electric.set(electric.get() + (BuildHeatingModel.getElectric(matchedDevice.getCount(), matchedDevice.getDeviceHeatScene().getDevPower(), days)));
        }));
        jsonObject.put("startCost", decimalFormat.format(startCost.get()));
        jsonObject.put("yearRunCost", decimalFormat.format(runCost.get()));
        jsonObject.put("yearCost", decimalFormat.format(allCost.get()));
        jsonObject.put("calculate", decimalFormat.format(calculateAnnualCarbon.get()));
        jsonObject.put("electric", decimalFormat.format(electric.get()));
        jsonObject.put("planInfos", planInfos.get().replace("null",""));
        jsonObject.put("devTechType", devTechType.get().replace("null",""));
        jsonObject.put("devSubType", devSubType.get().replace("null",""));
        jsonObject.put("devCount", devCount.get().replace("null",""));
        jsonObject.put("devPrice", devPrice.get().replace("null",""));
        jsonObject.put("devCost", decimalFormat.format(startCost.get()));
        jsonObject.put("safety", "精准控温");
        jsonObject.put("matchedDeviceList", maps);
        jsonObject.put("economy", Advantage.economy(startCost.get(), allCost.get(), runCost.get(), lastYearFee));
        jsonObject.put("intelligence", Advantage.intelligence());
        jsonObject.put("environment", Advantage.environment(Double.valueOf(decimalFormat.format(calculateAnnualCarbon.get()))));

        return jsonObject;
    }
}
